package org.dromara.mall.promotion.service;

import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.mall.promotion.domain.bo.MallGroupBuyBo;
import org.dromara.mall.promotion.domain.vo.MallGroupBuyVo;

import java.util.Collection;
import java.util.List;

/**
 * 拼团活动Service接口
 *
 * @author pengles
 */
public interface MallGroupBuyService {

    /**
     * 查询拼团活动
     */
    MallGroupBuyVo queryById(Long id);

    /**
     * 查询拼团活动列表
     */
    TableDataInfo<MallGroupBuyVo> queryPageList(MallGroupBuyBo bo, PageQuery pageQuery);

    /**
     * 查询拼团活动列表
     */
    List<MallGroupBuyVo> queryList(MallGroupBuyBo bo);

    /**
     * 查询可用的拼团活动列表（移动端）
     */
    List<MallGroupBuyVo> queryAvailableList();

    /**
     * 根据SKU ID查询拼团活动
     */
    MallGroupBuyVo queryBySkuId(Long skuId);

    /**
     * 新增拼团活动
     */
    Boolean insertByBo(MallGroupBuyBo bo);

    /**
     * 修改拼团活动
     */
    Boolean updateByBo(MallGroupBuyBo bo);

    /**
     * 校验并批量删除拼团活动信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 启用/禁用拼团活动
     */
    Boolean changeStatus(Long id, Integer status);

}
